<?php declare(strict_types=1);

namespace Micropayment\Service;

use Shopware\Core\System\SystemConfig\SystemConfigService;

class Config
{
    public const SYSTEM_CONFIG_DOMAIN = 'Micropayment.config.';

    /**
     * @var SystemConfigService
     */
    private $systemConfigService;

    public function __construct(SystemConfigService $systemConfigService)
    {
        $this->systemConfigService = $systemConfigService;
    }

    /**
     * getSettings
     *
     * @param string|null                        $salesChannelId
     * @param \Micropayment\Service\Context|null $context
     *
     * @return array
     */
    public function getSettings(?string $salesChannelId = null, ?Context $context = null)
    {
        $conf = [];
        $systemConfigData = $this->systemConfigService->getDomain(self::SYSTEM_CONFIG_DOMAIN, $salesChannelId, true);

        foreach ($systemConfigData as $key => $value) {
            if (stripos($key, self::SYSTEM_CONFIG_DOMAIN) !== false) {
                $conf[substr($key, strlen(self::SYSTEM_CONFIG_DOMAIN))] = $value;
            } else {
                $conf[$key] = $value;
            }
        }

        return $conf;
    }

}
