<?php

namespace Micropayment\Service\Method;

use Micropayment\Helper\McPayment;
use Micropayment\Service\Config;
use Micropayment\Service\WebPay;
use Shopware\Core\Checkout\Order\Aggregate\OrderTransaction\OrderTransactionStateHandler;
use Shopware\Core\Framework\DataAbstractionLayer\EntityRepository;

class PaydirektWeb extends WebPay
{
    public const PAYMENT_METHOD_NAME = 'PAYDIREKT_WEB';

    /**
     * SepaWeb constructor.
     *
     * @param \Shopware\Core\Checkout\Order\Aggregate\OrderTransaction\OrderTransactionStateHandler $transactionStateHandler
     * @param \Micropayment\Service\Config                                                          $config
     * @param \Micropayment\Helper\McPayment                                                        $mcp
     * @param \Shopware\Core\Framework\DataAbstractionLayer\EntityRepository               $localeRepo
     */
    public function __construct(
        OrderTransactionStateHandler $transactionStateHandler,
        Config $config,
        McPayment $mcp,
        EntityRepository $localeRepo
    )
    {
        $this->paymethod = self::PAYMENT_METHOD_NAME;
        parent::__construct($transactionStateHandler, $config, $mcp, $localeRepo);
    }
}
