<?php declare(strict_types=1);

namespace Micropayment\Storefront\Controller;

use Micropayment\Helper\McPayment;
use Micropayment\Service\Config;
use Micropayment\Helper\PaymentStatusHelper;
use Shopware\Core\Framework\Routing\Annotation\RouteScope;
use Shopware\Core\System\SalesChannel\SalesChannelContext;
use Shopware\Storefront\Controller\StorefrontController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route(defaults: ['_routeScope' => ['storefront']])]
#[Package('storefront')]
class CancelController extends StorefrontController
{
    /** @var \Micropayment\Helper\McPayment */
    protected $McPay;

    /** @var \Micropayment\Service\Config */
    protected $config;

    /** @var \Micropayment\Helper\PaymentStatusHelper */
    protected $psh;


    public function __construct(
        McPayment $McPay,
        Config $config,
        PaymentStatusHelper $psh
    )
    {
        $this->McPay  = $McPay;
        $this->config = $config;
        $this->psh    = $psh;
    }

  #[Route(path:"/micropayment/cancel/", name:"frontend.micropayment.cancel", options:["seo"=>"false"], methods:["GET", "POST"], defaults:["csrf_protected"=>false])]
  /**
     * @ Route("/micropayment/cancel/", defaults={"csrf_protected"=false}, name="frontend.micropayment.cancel",
     *                                           options={"seo"="false"}, methods={"GET", "POST"})
     * cancel
     *
     * @param \Shopware\Core\System\SalesChannel\SalesChannelContext $SalesChannelContext
     *
     * @return \Symfony\Component\HttpFoundation\Response|null
     */
    public function cancel(
        SalesChannelContext $SalesChannelContext
    ): ?Response
    {
        //echo '<pre>'.print_r(func_get_args(),true).'</pre>';
        //echo __FUNCTION__.' called!';
        $settings = $this->config->getSettings($SalesChannelContext->getSalesChannel()->getId());
        //echo '<pre>'.print_r($settings,true).'</pre>';
        $this->McPay->init($settings);
        //echo '<pre>'.print_r($this->mcp,true).'</pre>';
        $return = '';
        $crlf   = "\r\n";

//        if (empty($post['trxid'])) $return = 'status=error'.$crlf.'message=TRX ID missing.';
//        else                          $trxid = $post['trxid'];
//
//        if (!empty($return)) {
//            //echo $return;
//            return new Response($return);
//        }
//
//        $context = $SalesChannelContext->getContext();
//        $state   = 'cancel';
//        $this->psh->setState($trxid, $state, $context);
//
//        $return = 'Cancel '.$trxid.' successfull!';
        $return = 'Cancel successfull!';

        $this->McPay->log->debug(__CLASS__.'->'.__FUNCTION__.'->return: '.$return);

        return new RedirectResponse('/'); // redirect to shop

        return new Response($return); // show message
    }
}
