<?php declare(strict_types=1);

namespace Micropayment\Storefront\Controller;

use Micropayment\Helper\McPayment;
use Micropayment\Service\Config;
use Micropayment\Helper\PaymentStatusHelper;
use Shopware\Core\Framework\Routing\Annotation\RouteScope;
use Shopware\Core\System\SalesChannel\SalesChannelContext;
use Shopware\Storefront\Controller\StorefrontController;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route(defaults: ['_routeScope' => ['storefront']])]
#[Package('storefront')]
class ErrorController extends StorefrontController
{
    /** @var \Micropayment\Helper\McPayment */
    protected $McPay;

    /** @var \Micropayment\Service\Config */
    protected $config;

    /** @var \Micropayment\Helper\PaymentStatusHelper */
    protected $psh;


    public function __construct(
        McPayment $McPay,
        Config $config,
        PaymentStatusHelper $psh
    )
    {
        $this->McPay  = $McPay;
        $this->config = $config;
        $this->psh    = $psh;
    }

  #[Route(path:"/micropayment/error/", name:"frontend.micropayment.error", options:["seo"=>"false"], methods:["GET", "POST"], defaults:["csrf_protected"=>false])]
  /**
     * @ Route("/micropayment/error/", defaults={"csrf_protected"=false}, name="frontend.micropayment.error",
     *                                           options={"seo"="false"}, methods={"GET", "POST"})
     * error
     *
     * @param \Shopware\Core\System\SalesChannel\SalesChannelContext $SalesChannelContext
     *
     * @return \Symfony\Component\HttpFoundation\Response|null
     */
    public function error(
        SalesChannelContext $SalesChannelContext
    ): ?Response
    {
        //echo '<pre>'.print_r(func_get_args(),true).'</pre>';
        //echo __FUNCTION__.' called!';
        $settings = $this->config->getSettings($SalesChannelContext->getSalesChannel()->getId());
        //echo '<pre>'.print_r($settings,true).'</pre>';
        $this->McPay->init($settings);
        //echo '<pre>'.print_r($this->mcp,true).'</pre>';

        $return = 'Unknown Error occured!';

        $this->McPay->log->debug(__CLASS__.'->'.__FUNCTION__.'->return: '.$return);

        return new RedirectResponse('/'); // redirect to shop

        return new Response($return);
    }
}
